hdu 6319 Problem A. Ascending Rating(单调队列)

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/Timeclimber/article/details/82227373

Problem A. Ascending Rating

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
Total Submission(s): 5203    Accepted Submission(s): 1794


 

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

 

Input

The first line of the input contains an integer T(1≤T≤2000), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109), denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD


It is guaranteed that ∑n≤7×107 and ∑k≤2×106.

 

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1].
For each test case, you need to print a single line containing two integers A and B, where :

AB==∑i=1n−m+1(maxratingi⊕i)∑i=1n−m+1(counti⊕i)


Note that ``⊕'' denotes binary XOR operation.

 

Sample Input

 

1 10 6 10 5 5 5 5 3 2 2 1 5 7 6 8 2 9

 

Sample Output

 

46 11

 

Source

2018 Multi-University Training Contest 3

 题意:

给了前K个数,以及构造该数列的方法。要求每连续长度为M的数列中最大值异或上该数列的开头的下标i和该连续长度为M的数列中更换的次数异或上i。

 

思路:

很明显的滑动窗口的题目,即单调队列。不过在求最大值的时候,队列中维护的是单调下降的数列。所以先将数组翻转过来再来求,得到的就是原数组的单调上升的数列。

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <queue>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
const int maxn=1e7+5;
int n,m,k,p,qq,r,mod;
ll sum1,sum2;
int q[maxn];
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d%d%d%d%d%d",&n,&m,&k,&p,&qq,&r,&mod);
        vector<ll> a(n+2);
        sum1=sum2=0;
        for(int i=1; i<=k; i++)
        {
            scanf("%d",&a[i]);
        }
        for(int i=k+1; i<=n; i++)
        {
            a[i]=(ll)(p*a[i-1]+(ll)qq*i+(ll)r)%mod;
        }
        int head=1,tail=1;
        reverse(a.begin(),a.end());
        head=1,tail=1;
        for(int i=1; i<=n; i++)
        {
            while(head<tail&&a[q[tail-1]]<=a[i])
                tail--;
            q[tail++]=i;
            if(q[head]<i-m+1)
                head++;
            if(i>=m)
            {
                sum1=sum1+(a[q[head]]^(ll)(n+1-i));
                sum2=sum2+((n+1-i)^(ll)(tail-head));
            }
        }
        printf("%lld %lld\n",sum1,sum2);
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/Timeclimber/article/details/82227373